<?
define("STOP_STATISTICS", true);

require_once($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/main/include/prolog_before.php");

require_once($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/main/classes/general/wizard.php");

$wizard =  new CWizard("grain:code.fill");
$wizard->IncludeWizardLang("scripts/script.php", $lang);

$lang=$_REQUEST["WIZ_UNI_LANG"];

$wizard_path = $_SERVER["DOCUMENT_ROOT"].($wizard->GetPath());
$spath=pathinfo(__FILE__);
if ($lang=="ru") __IncludeLang($wizard_path."/lang/ru-".strtolower(LANG_CHARSET)."/scripts/".$spath["basename"]);
else __IncludeLang($wizard_path."/lang/en/scripts/".$spath["basename"]);

$mainModulePermissions = $APPLICATION->GetGroupRight("main");
if ($mainModulePermissions < "W")
{
	echo GetMessage('WIZ_UNI_ERROR_ACCESS_DENIED');
	require_once($_SERVER["DOCUMENT_ROOT"].BX_ROOT."/modules/main/include/epilog_after.php");
	die();
}


define("WIZ_UNI_VARS_DIR",($wizard->GetPath())."/temp/");

$wizard->IncludeWizardLang("scripts/functions.php", $lang);
if ($lang=="ru") __IncludeLang($wizard_path."/lang/ru-".strtolower(LANG_CHARSET)."/scripts/functions.php");
else __IncludeLang($wizard_path."/lang/en/scripts/functions.php");
require_once($_SERVER["DOCUMENT_ROOT"].$wizard->GetPath()."/scripts/functions.php");


$VARS = GUniWizardTools::GetVars();

if (!is_array($VARS))
{
	echo "Error while parsing vars temp file";
	require_once($_SERVER["DOCUMENT_ROOT"].BX_ROOT."/modules/main/include/epilog_after.php");
	die();
}

define("WIZ_UNI_DATA_DIR", $VARS["WIZ_UNI_DATA_DIR"]);

$step_length = intval($_REQUEST["STEP_LENGTH"]);
if ($step_length <= 0) $step_length = 10;

$STEP = intval($_REQUEST['STEP']);


if($STEP==0):

		$NEXT_STEP = $STEP+1;
    	echo GetMessage('WIZ_UNI_STEP_RUN',Array("#STEP#"=>$NEXT_STEP));
    	echo "<script>RunScript(".$NEXT_STEP.")</script>";


elseif($STEP<=1000):

    
    	//$time_limit = ini_get('max_execution_time');
    	//if ($time_limit < $step_length) set_time_limit($step_length + 5);
    	$start_time = time();
    	$finish_time = $start_time + $step_length;

		$bFinish = true;
	
		$cur_step = 0;
		$added = 0;

   		if (is_set($_SESSION["WIZ_UNI_POS"])) $cur_step = $_SESSION["WIZ_UNI_POS"];
   		if (is_set($_SESSION["WIZ_UNI_ADDED"])) $added = $_SESSION["WIZ_UNI_ADDED"];

		require($_SERVER["DOCUMENT_ROOT"].$wizard->GetPath()."/scripts/step".$STEP.".php");

		GUniWizardTools::StoreVars($VARS);
		GUniWizardTools::StorePersonalErrorLog();

   		$errors = GUniWizardTools::GetErrorCount();

    	if ($bFinish)
    	{
    	
    		$strOK = GetMessage('WIZ_UNI_STATS_ELEMENTS'.($errors>0?"_ERROR":""),Array("#NUMELEMENTS#"=>$added,"#ERRORS#"=>$errors["ERRORS"],"#WARNINGS#"=>$errors["WARNINGS"],"#MESSAGES#"=>$errors["MESSAGES"]));

			if(intval($errors["ERRORS"])>0 || intval($errors["WARNINGS"])>0 || intval($errors["MESSAGES"])>0) {

				$strOK .= "<table class='uni-table-errors'>";
				
				$arLog = GUniWizardTools::GetErrorLog();
			
				foreach($arLog as $arError) {

					$strOK .= "<tr>";
					$strOK .= "<td class=\"uni-table-errors-col-".$arError["TYPE"]."\">".$arError["ERROR"]."</td>";
					$strOK .= "<td class=\"uni-table-errors-col-".$arError["TYPE"]."\">".$arError["COUNT"]."</td>";
					$strOK .= "</tr>";
				
				}

				$strOK .= "</table><br />";
			
			}

    		unset($_SESSION["WIZ_UNI_POS"]);
    		unset($_SESSION["WIZ_UNI_ADDED"]);
			unset($_SESSION["WIZ_UNI_ERROR_LOG"]);
   		
    		echo $strOK;

			$NEXT_STEP = $STEP+1;

			if(!file_exists($_SERVER["DOCUMENT_ROOT"].$wizard->GetPath()."/scripts/step".$NEXT_STEP.".php")) $NEXT_STEP = 1001;

			if($NEXT_STEP<=1000) echo GetMessage('WIZ_UNI_STEP_RUN',Array("#STEP#"=>$NEXT_STEP));

	   		echo '<script>RunScript('.$NEXT_STEP.');</script>';

    	} else {

   			$_SESSION["WIZ_UNI_POS"] = $cur_step;
   			$_SESSION["WIZ_UNI_ADDED"] = $added;

			$errors = GUniWizardTools::GetErrorCount();

   			echo "<script>RunScript(".$STEP.", {AMOUNT:".CUtil::JSEscape($ElementsCount).",POS:".CUtil::JSEscape($cur_step).($errors["ERRORS"]>0?",ERROR_MESSAGE:'".CUtil::JSEscape(GetMessage("WIZ_UNI_ERRORS_PROGRESSBAR").": ".$errors["ERRORS"])."'":"").($errors["WARNINGS"]>0?",WARNING_MESSAGE:'".CUtil::JSEscape(GetMessage("WIZ_UNI_WARNINGS_PROGRESSBAR").": ".$errors["WARNINGS"])."'":"").($errors["MESSAGES"]>0?",MESSAGE_MESSAGE:'".CUtil::JSEscape(GetMessage("WIZ_UNI_MESSAGES_PROGRESSBAR").": ".$errors["MESSAGES"])."'":"")."});</script>";

    	
    	
    	}
    	
    
elseif($STEP>1000):

    	echo GetMessage('WIZ_UNI_ALL_DONE');
    	echo '<script>EnableButton();</script>';

endif;


require_once($_SERVER["DOCUMENT_ROOT"].BX_ROOT."/modules/main/include/epilog_after.php");
?>